#pragma once

#include "core/sprite.h"
#include "core/point.h"
#include "core/color.h"
#include "core/rectangle.h"

#include <memory>

class ClassicNoteGraphics
{
public:

    struct Init
    {
        std::shared_ptr<kku::Rectangle> shape;
        std::shared_ptr<kku::Rectangle> trail;
        kku::Color color;
    };

    ClassicNoteGraphics(ClassicNoteGraphics::Init&& init);
    void reset();
    void display() const;

    void setPosition(const kku::Point &position);
    void setTrailPosition(const kku::Point &position);
    kku::Point getPosition() const;
    kku::Point getTrailPosition() const;

    void setColor(const kku::Color& color);
    void setTrailColor(const kku::Color& color);
    kku::Color getColor() const;
    kku::Color getTrailColor() const;

    std::shared_ptr<const kku::Rectangle> getRectangle() const;

protected:
    kku::Color _reset_color;
    std::shared_ptr<kku::Rectangle> _shape;
    std::shared_ptr<kku::Rectangle> _trail;
};
